# 
#
# Generated by dumpDCWorkflow.py written by Sebastien Bigaret
# Original workflow id/title: ploneicalendar_workflow/PloneiCalendar Default Workflow
# Date: 2004/05/12 15:12:23.390 GMT+2
#
# WARNING: this dumps does NOT contain any scripts you might have added to
# the workflow, IT IS YOUR RESPONSABILITY TO MAKE BACKUPS FOR THESE SCRIPTS.
#
# No script detected in this workflow
# 
"""
Programmatically creates a workflow type
"""
__version__ = "$Revision: 1.5 $"[11:-2]

from Products.CMFCore.WorkflowTool import addWorkflowFactory

from Products.DCWorkflow.DCWorkflow import DCWorkflowDefinition

def setupPloneicalendar_workflow(wf):
    "..."
    wf.setProperties(title='PloneiCalendar Default Workflow')

    for s in ['private', 'published']:
        wf.states.addState(s)
    for t in ['retract', 'publish']:
        wf.transitions.addTransition(t)
    for v in ['action', 'time', 'comments', 'actor', 'review_history']:
        wf.variables.addVariable(v)
    for l in []:
        wf.worklists.addWorklist(l)
    for p in ('Modify portal content', 'View', 'WebDAV Lock items', 'WebDAV Unlock items', 'WebDAV access', 'FTP access'):
        wf.addManagedPermission(p)
        

    ## Initial State
    wf.states.setInitialState('private')

    ## States initialization
    sdef = wf.states['private']
    sdef.setProperties(title="""Private. Editable by LocalWriter. View content for LocalReader""",
                       transitions=('publish',))
    sdef.setPermission('Modify portal content', 0, ['LocalWriter', 'Manager', 'Owner'])
    sdef.setPermission('View', 0, ['LocalReader', 'LocalWriter', 'Manager', 'Owner'])
    sdef.setPermission('WebDAV Lock items', 0, ['LocalReader', 'LocalWriter'])
    sdef.setPermission('WebDAV Unlock items', 0, ['LocalReader', 'LocalWriter'])
    sdef.setPermission('WebDAV access', 0, ['LocalReader', 'LocalWriter'])
    sdef.setPermission('FTP access', 0, ['LocalReader', 'LocalWriter', 'Manager'])

    sdef = wf.states['published']
    sdef.setProperties(title="""Public""",
                       transitions=('retract',))
    sdef.setPermission('Modify portal content', 0, ['Manager'])
    sdef.setPermission('View', 0, ['Anonymous', 'Manager'])
    sdef.setPermission('WebDAV Lock items', 1, [])
    sdef.setPermission('WebDAV Unlock items', 1, [])
    sdef.setPermission('WebDAV access', 1, [])
    sdef.setPermission('FTP access', 1, [])


    ## Transitions initialization
    tdef = wf.transitions['retract']
    tdef.setProperties(title="""Owner makes content private""",
                       new_state_id="""private""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""""",
                       actbox_name="""Retract""",
                       actbox_url="""%(content_url)s/content_retract_form""",
                       actbox_category="""workflow""",
                       props={'guard_roles': 'Owner'},
                       )

    tdef = wf.transitions['publish']
    tdef.setProperties(title="""Owner publishes content""",
                       new_state_id="""published""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""""",
                       actbox_name="""Publish""",
                       actbox_url="""%(content_url)s/content_publish_form""",
                       actbox_category="""workflow""",
                       props={'guard_roles': 'Owner'},
                       )

    ## State Variable
    wf.variables.setStateVar('review_state')

    ## Variables initialization
    vdef = wf.variables['action']
    vdef.setProperties(description="""The last transition""",
                       default_value="""""",
                       default_expr="""transition/getId|nothing""",
                       for_catalog=0,
                       for_status=1,
                       update_always=1,
                       props=None)

    vdef = wf.variables['time']
    vdef.setProperties(description="""Time of the last transition""",
                       default_value="""""",
                       default_expr="""state_change/getDateTime""",
                       for_catalog=0,
                       for_status=1,
                       update_always=1,
                       props=None)

    vdef = wf.variables['comments']
    vdef.setProperties(description="""Comments about the last transition""",
                       default_value="""""",
                       default_expr="""python:state_change.kwargs.get('comment', '')""",
                       for_catalog=0,
                       for_status=1,
                       update_always=1,
                       props=None)

    vdef = wf.variables['actor']
    vdef.setProperties(description="""The ID of the user who performed the last transition""",
                       default_value="""""",
                       default_expr="""user/getId""",
                       for_catalog=0,
                       for_status=1,
                       update_always=1,
                       props=None)

    vdef = wf.variables['review_history']
    vdef.setProperties(description="""Provides access to workflow history""",
                       default_value="""""",
                       default_expr="""state_change/getHistory""",
                       for_catalog=0,
                       for_status=0,
                       update_always=0,
                       props={'guard_permissions': 'Request review; Review portal content'})

    ## Worklists Initialization

def createPloneicalendar_workflow(id):
    "..."
    ob = DCWorkflowDefinition(id)
    setupPloneicalendar_workflow(ob)
    return ob

addWorkflowFactory(createPloneicalendar_workflow,
                   id='ploneicalendar_workflow',
                   title='PloneiCalendar Default Workflow')

    
