##############################################################################
#
# Copyright (c) 2002 Ingeniweb SARL
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.0 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE
#
##############################################################################

"""PloneiCalendar"""
import datetime

import AccessControl.Permissions
import PloneiCalendar, PloneiCalendarTool


from global_symbols import *

from AccessControl.Permissions import *

from Products.CMFCore.DirectoryView import registerDirectory
from Products.CMFCore import utils, CMFCorePermissions

from AccessControl import allow_module, allow_class

registerDirectory('skins', globals())
registerDirectory('skins/ploneicalendar', globals())

install_globals = globals()          # Used only in the Extensions/Install.py script


# Classes & constructors declaration
contentClasses = (PloneiCalendar.PloneiCalendar, )
contentConstructors = (PloneiCalendar.addPloneiCalendar, )

#allow_class(datetime.datetime)

# Initialization method
def initialize(context):
    utils.ToolInit('PloneiCalendar Tools', 
                   tools=( PloneiCalendarTool.PloneiCalendarTool, ), 
                   product_name='PloneiCalendar', 
                   icon='tool.gif',  
                   ).initialize(context) 
                   
    utils.ContentInit(
        'PloneiCalendar',
        content_types = contentClasses,
        permission = PloneiCalendar_addPermission,
        extra_constructors = contentConstructors,
        fti = (PloneiCalendar.factory_type_information,),
        ).initialize(context)
